//
//      SimpleCamera.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1 (English Edition)
//

#ifndef __SIMPLECAMERA_HPP
#define __SIMPLECAMERA_HPP

#include <SophiaFramework.hpp>
#include "SimpleCamera.bid"
#include "Camera.hpp"

SFMTYPEDEFCLASS(SimpleCamera)

class SimpleCamera : public SFCApplication {

    SFMSEALCOPY(SimpleCamera)

public:

    static SFCInvokerPtr Factory(Void);

private:

    Camera _camera;
    enum AppStatus { STATUS_NONE = 0, STATUS_PREVIEW, STATUS_SNAP };
    AppStatus _status;
    SInt16 _brightnessMin;      // Minimum value of brightness
    SInt16 _brightnessMax;      // Maximum value of brightness
    SInt16 _brightness;         // Present brightness
    SInt16 _zoomMin;            // Minimum value of zoom
    SInt16 _zoomMax;            // Maximum value of zoom
    SInt16 _zoom;               // Current zoom value

    SimpleCamera(Void);
    virtual ~SimpleCamera(Void);
    virtual Bool Invoke(SFXEventConstRef event);
    Void OnAppStart(AEEAppStartPtr environment);
    Void OnAppStop(BoolPtr quitable);
    Bool OnKey(UInt16 key);

    // Camera event callback function
    static Void CameraCallback(Camera::StatusEnum status, SFCError error, VoidPtr reference);

    // Camera event handler
    Void OnCamera(Camera::StatusEnum status, SFCError error);

    // For displaying error messages
    Void PrintError(SFXWideStringConstRef msg);

    // Start to preview
    Void PreviewCamera(Void);

    // Process and display photo image taken in snapshot mode
    Void DisplayImage(Void);

    // Change brightness
    Void ChangeBrightness(Bool isBrighter);

    // Change zoom value
    Void ChangeZoom(Bool isZoomIn);
};

#endif // __SIMPLECAMERA_HPP //
